diff -Nru t1lib-grace/T1lib/t1lib/t1lib.h t1lib-deb/T1lib/t1lib/t1lib.h
--- t1lib-grace/T1lib/t1lib/t1lib.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1lib.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,12 +1,12 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1lib.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-10-03
+  ----- Date:        2004-12-19
   ----- Description: This file is part of the t1-library. It must be
                      included by the user of the t1lib. It contains
 		     function declarations and some basic data types, the
 		     user must deal with.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2004.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -38,6 +38,15 @@
 extern "C" {
 #endif
 
+/* Version information filled in by configure */
+#define T1LIB_VERSION            5
+#define T1LIB_REVISION           1
+#define T1LIB_PATCHLEVEL         2
+#define T1LIB_VERSIONSTRING      "5.1.2"
+
+/* Data Type information filled in by configure. */
+typedef short T1_int16;
+typedef int T1_int32;
 
 /* the data structure which contains the character bitmap description */
 typedef struct
@@ -165,6 +174,7 @@
 #define T1ERR_NO_AFM_DATA             16
 #define T1ERR_X11                     17
 #define T1ERR_COMPOSITE_CHAR          18
+#define T1ERR_SCAN_ENCODING           19
 
 
 /* Flags to control the rasterizer */
@@ -182,14 +192,14 @@
 /* definitions for outline handling */
 #define   FRACTBITS     16   /* number of fractional bits in 'fractpel'      */
 /* From/to conversion of pels/fractpels */
-#define   T1_TOPATHPOINT(p)      (((long)p)<<FRACTBITS)
+#define   T1_TOPATHPOINT(p)      (((T1_int32)p)<<FRACTBITS)
 #define   PPHALF                 (1<<(FRACTBITS-1))
 #define   T1_NEARESTPOINT(fp)    (((fp)+PPHALF)>>FRACTBITS)
 
 /* A fractional point */
 typedef struct {
-  long x;
-  long y;
+  T1_int32 x;
+  T1_int32 y;
 } T1_PATHPOINT;
 
 
@@ -264,17 +274,13 @@
 extern int T1_AddFont( char *fontfilename);
 extern void T1_PrintLog( char *func_ident, char *msg_txt, int level, ...);
 extern void T1_SetLogLevel( int level);
-extern int CheckForInit(void);
-extern int CheckForFontID( int FontID);
-extern int test_for_t1_file( char *buffer );
+extern int T1_CheckForInit(void);
+extern int T1_CheckForFontID( int FontID);
 extern char *T1_GetFontFileName( int FontID);
-extern int  T1_Get_no_fonts(void);
+extern int  T1_GetNoFonts(void);
 extern int T1_SetDeviceResolutions( float x_res, float y_res);
 extern int T1_CopyFont( int FontID);
 extern int T1_QueryX11Support( void);
-extern void bin_dump_c(unsigned char value);
-extern void bin_dump_s(unsigned short value);
-extern void bin_dump_l(unsigned long value);
 extern int T1_CheckEndian(void);
 extern int T1_SetBitmapPad( int pad);
 extern int T1_GetBitmapPad( void);
@@ -284,6 +290,7 @@
 extern int T1_SetAfmFileName( int FontId, char *afm_name);
 extern char *T1_GetFontFilePath( int FontID);
 extern char *T1_GetAfmFilePath( int FontID);
+extern const char *T1_StrError( int t1err);
 
 /* from t1delete.c */
 extern int T1_DeleteSize( int FontID, float size);
@@ -345,10 +352,7 @@
 
 /* from t1load.c */
 extern int T1_LoadFont( int FontID);
-extern int openFontMetricsFile( int FontID);
-extern void *CreateNewFontSize( int FontID, float size, int aa);
-extern void *GetLastFontSize( int FontID);
-extern void *QueryFontSize( int FontID, float size, int aa);
+extern void *T1_QueryFontSize( int FontID, float size, int aa);
 
 /* from t1set.c */
 extern GLYPH *T1_SetChar( int FontID, char charcode, 
@@ -356,6 +360,9 @@
 extern GLYPH *T1_SetString( int FontID, char *string, int len,
 			    long spaceoff, int modflag,
 			    float size, T1_TMATRIX *transform);
+extern GLYPH* T1_SetRect( int FontID, float size,
+			  float width, float height,
+			  T1_TMATRIX *transform);
 extern GLYPH *T1_CopyGlyph(GLYPH *glyph);
 extern void T1_DumpGlyph( GLYPH *glyph);
 extern GLYPH *T1_ConcatGlyphs( GLYPH *glyph1, GLYPH *glyph2,
@@ -384,6 +391,12 @@
 extern T1_TMATRIX *T1_TransformMatrix( T1_TMATRIX *matrix,
 				       double cxx, double cyx,
 				       double cxy, double cyy);
+extern int T1_StrokeFont( int FontID, int dostroke);
+extern int T1_SetStrokeFlag( int FontID);
+extern int T1_ClearStrokeFlag( int FontID);
+extern int T1_GetStrokeMode( int FontID);
+extern int T1_SetStrokeWidth( int FontID, float strokewidth);
+extern float T1_GetStrokeWidth( int FontID);
 
 
 /* from t1aaset.c */
@@ -392,6 +405,9 @@
 extern GLYPH *T1_AASetString( int FontID, char *string, int len,
 			      long spaceoff, int modflag,
 			      float size, T1_TMATRIX *transform);
+extern GLYPH* T1_AASetRect( int FontID, float size,
+			    float width, float height,
+			    T1_TMATRIX *transform);
 extern int T1_AASetGrayValues(unsigned long white,
 			      unsigned long gray75,
 			      unsigned long gray50,
diff -Nru t1lib-grace/T1lib/t1lib/t1libx.h t1lib-deb/T1lib/t1lib/t1libx.h
--- t1lib-grace/T1lib/t1lib/t1libx.h	1969-12-31 16:00:00.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1libx.h	2007-12-23 07:49:42.000000000 -0800
@@ -0,0 +1,93 @@
+/*--------------------------------------------------------------------------
+  ----- File:        t1libx.h
+  ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
+  ----- Date:        2003-01-02
+  ----- Description: This file is part of the t1-library. It must be
+                     included by the user of the t1lib. It contains
+		     function declarations for the X11 wrapper.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2003.
+                     As of version 0.5, t1lib is distributed under the
+		     GNU General Public Library Lincense. The
+		     conditions can be found in the files LICENSE and
+		     LGPL, which should reside in the toplevel
+		     directory of the distribution.  Please note that 
+		     there are parts of t1lib that are subject to
+		     other licenses:
+		     The parseAFM-package is copyrighted by Adobe Systems
+		     Inc.
+		     The type1 rasterizer is copyrighted by IBM and the
+		     X11-consortium.
+  ----- Warranties:  Of course, there's NO WARRANTY OF ANY KIND :-)
+  ----- Credits:     I want to thank IBM and the X11-consortium for making
+                     their rasterizer freely available.
+		     Also thanks to Piet Tutelaers for his ps2pk, from
+		     which I took the rasterizer sources in a format
+		     independent from X11.
+                     Thanks to all people who make free software living!
+--------------------------------------------------------------------------*/
+
+
+#ifndef T1LIBX_H_INCLUDED
+
+#define T1LIBX_H_INCLUDED
+
+
+#ifndef _XLIB_H_
+#include <X11/Xlib.h>
+#endif
+
+
+#define T1LIB_X11_SUPPORT
+
+/* For paint mode of X-rastering functions */
+#define T1_OPAQUE              0x1
+#define T1_TRANSPARENT         0x0
+
+
+/* type definitions, needed by the user: */
+
+#if defined(__cplusplus) || defined(c_plusplus)
+extern "C" {
+#endif
+
+
+/* from t1x11.c */
+extern int T1_SetX11Params( Display *display,
+			    Visual *visual,
+			    unsigned int depth,
+			    Colormap colormap);
+extern GLYPH *T1_SetCharX( Drawable d, GC gc, int mode, int x, int y,
+			   int FontID, char charcode,
+			   float size, T1_TMATRIX *transform);
+extern GLYPH *T1_SetStringX( Drawable d, GC gc, int mode, int x, int y,
+			     int FontID, char *string, int len,
+			     long spaceoff, int modflag,
+			     float size, T1_TMATRIX *transform);
+extern GLYPH *T1_SetRectX( Drawable d, GC gc, int mode, int x_dest, int y_dest,
+			   int FontID, float size,
+			   float width, float height,
+			   T1_TMATRIX *transform);
+extern GLYPH *T1_AASetCharX( Drawable d, GC gc, int mode, int x, int y,
+			     int FontID, char charcode,
+			     float size, T1_TMATRIX *transform);
+extern GLYPH *T1_AASetStringX( Drawable d, GC gc, int mode, int x, int y,
+			       int FontID, char *string, int len,
+			       long spaceoff, int modflag,
+			       float size, T1_TMATRIX *transform);
+extern GLYPH *T1_AASetRectX( Drawable d, GC gc, int mode, int x_dest, int y_dest,
+			     int FontID, float size,
+			     float width, float height,
+			     T1_TMATRIX *transform);
+extern int T1_ComputeAAColorsX( unsigned long fg,
+				unsigned long bg,
+				int nolevels);
+extern int T1_GetDepthOfDrawable( Drawable drawable);
+extern void T1_LogicalPositionX( int pos_switch);
+extern XImage *T1_XImageFromGlyph( GLYPH *pglyph);
+
+  
+#if defined(__cplusplus) || defined(c_plusplus)
+}
+#endif
+
+#endif /* T1LIBX_H_INCLUDED */
diff -Nru t1lib-grace/T1lib/t1lib/t1load.c t1lib-deb/T1lib/t1lib/t1load.c
--- t1lib-grace/T1lib/t1lib/t1load.c	2002-07-29 13:37:48.000000000 -0700
+++ t1lib-deb/T1lib/t1lib/t1load.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1load.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-10-03
+  ----- Date:        2007-12-23
   ----- Description: This file is part of the t1-library. It contains
                      functions for loading fonts  and for managing size
 		     dependent data.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2007. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -30,6 +30,15 @@
 
 #define ANSI_REALLOC_VM  
 
+/* Note: On some systems, like e.g. my Linux box, realloc() frequently returns
+         the identical pointer, if the memory chunk is *decreased* in size. As
+	 a consequence, pointer shifting (as implemented below) would never
+	 actually appear. The following definition enforces pointer shifting,
+	 and hence allows to check pointer shifting on every system. Do not
+	 activate this, it is meant for testing only!
+*/
+/* #define ANSI_REALLOC_ENFORCE_POINTERSHIFTING */
+
 #include <stdio.h>
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -53,6 +62,7 @@
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
 #include "../type1/blues.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 
 
@@ -77,7 +87,7 @@
 
 int T1_LoadFont( int FontID)
 {
-  int i, j, k, l, m;
+  int i, j, k, l, m, n;
   char *FileName, *FileNamePath;
   int mode;  /* This is used by the type1-library for error reporting */   
   char *charname;
@@ -100,13 +110,13 @@
   int char1, char2;
   
   
-  if (CheckForInit()){
+  if (T1_CheckForInit()){
     T1_errno=T1ERR_OP_NOT_PERMITTED;
     return(-1);
   }
   
 
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i==1)
     return(0);      /* Font already loaded */
   if (i==-1){
@@ -150,6 +160,40 @@
   free(FileNamePath);
 
   
+  /* Set some default for FontBBox and Encoding if the font does not provide
+     correct data. Strictly taken, these fonts do not adhere to the Type1
+     specification. However, it is easy to work around and find reasonable
+     defaults. This solution has been proposed by the Debian community (see
+     http://bugs.debian.org/313236). */
+  /* 1. FontBBox. We set default values of 0 which is recommended by Adobe
+     in cases where the font does not make use of the SEAC primitive. Later on,
+     if AFM fallback info is computed, these settings might be overwritten with
+     meaningful values. */
+  if (pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP == NULL) {
+    if ((pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP =  
+	 (psobj *)vm_alloc(4 * sizeof(psobj))) == NULL) {
+      T1_PrintLog( "T1_LoadFont()", "Error allocating memory for fontbbox objects (FontID=%d)", 
+		   T1LOG_ERROR, FontID);
+      T1_errno=T1ERR_ALLOC_MEM;
+      return(-1);
+    }
+    for (n = 0; n < 4; n++) {
+      pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[n].type = OBJ_INTEGER;
+      pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[n].len = 0;
+      pFontBase->pFontArray[FontID].pType1Data->fontInfoP[FONTBBOX].value.data.arrayP[n].data.integer = 0;
+    }
+    T1_PrintLog( "T1_LoadFont()", "Missing FontBBox, adding a trivial one in order to avoid crashes (FontID=%d)", 
+		 T1LOG_WARNING, FontID);
+  }
+  /* 2. Encoding. In this case, we simply fallback to Standard Encoding. */
+  if (pFontBase->pFontArray[FontID].pFontEnc == NULL && 
+      pFontBase->pFontArray[FontID].pType1Data->fontInfoP[ENCODING].value.data.arrayP == NULL) {
+    pFontBase->pFontArray[FontID].pType1Data->fontInfoP[ENCODING].value.data.valueP = (char *) StdEncArrayP;
+    T1_PrintLog( "T1_LoadFont()", "Missing, invalid  or undefined Encoding, setting up Standard Encoding in order to avoid crashes (FontID=%d)", 
+		 T1LOG_WARNING, FontID);
+  }
+  
+  
   /* Store the base address of virtual memory and realloc in order not
      to waste too much memory: */
   pFontBase->pFontArray[FontID].vm_base=vm_base; 
@@ -158,7 +202,12 @@
   /* Get size of VM, ... */
   tmp_size=((unsigned long)vm_used - (unsigned long)vm_base); 
   /* ... realloc to that size ... */
-  tmp_ptr=(char *)realloc(vm_base,  tmp_size); 
+#ifdef ANSI_REALLOC_ENFORCE_POINTERSHIFTING
+  tmp_ptr=(char *)malloc( tmp_size);
+  memcpy( tmp_ptr, vm_base, tmp_size);
+#else
+  tmp_ptr=(char *)realloc(vm_base,  tmp_size);
+#endif
   /* ... and shift all pointers refering to that area */
   if (tmp_ptr > vm_base){
     shift= (unsigned long)tmp_ptr - (unsigned long)vm_base;
@@ -211,24 +260,18 @@
       }
       /* The encoding needs special treatment: */
       if (pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.type==OBJ_ENCODING){
-	/* If a builtin encoding is used, it is sufficient to shift the pointer
-	   to the Encoding since the character-namestrings of builtin encodings
-	   are static and thus located on the heap.
-	   For font-specific encoding, character-namestrings reside in VM and
-	   thus each entry has to be shifted. 
-	   Caution: We still have to shift the builtin encoding-pointer, since
-	   they also point to are located in VM: */
-	ldummy=(long)StdEncArrayP;
-	ldummy +=shift;
-	StdEncArrayP=(psobj *)ldummy;
-	ldummy=(long)pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.valueP;
-	ldummy +=shift;
-	pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.valueP=(char *)ldummy;
+	/* If builtin StandardEncoding is used, we do nothing here. Standard Encoding
+	   is now located once for all fonts on the heap. For font-specific encodings
+	   we have to move all pointers appropriately, because this is entirely located
+	   in VM */
 	if (pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.arrayP
-	    == StdEncArrayP){ /* Font uses builtin standard encoding */
+	    == StdEncArrayP){ /* Font uses builtin StandardEncoding */
 	  ;
 	} 
 	else{ /* Font-specific encoding */ 
+	  ldummy=(long)pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.valueP;
+	  ldummy +=shift;
+	  pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.valueP=(char *)ldummy;
 	  for (k=0; k<256; k++){
 	    ldummy=(long)pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.arrayP[k].data.arrayP;
 	    /* The ".notdef" is also static and may not be shifted (Thanks, Derek ;) */
@@ -346,24 +389,18 @@
       }
       /* The encoding needs special treatment: */
       if (pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.type==OBJ_ENCODING){
-	/* If a builtin encoding is used, it is sufficient to shift the pointer
-	   to the Encoding since the character-namestrings of builtin encodings
-	   are static and thus located on the heap.
-	   For font-specific encoding, character-namestrings reside in VM and
-	   thus each entry has to be shifted. 
-	   Caution: We still have to shift the builtin encoding-pointer, since
-	   they also point to are located in VM: */
-	ldummy=(long)StdEncArrayP;
-	ldummy -=shift;
-	StdEncArrayP=(psobj *)ldummy;
-	ldummy=(long)pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.valueP;
-	ldummy -=shift;
-	pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.valueP=(char *)ldummy;
+	/* If builtin StandardEncoding is used, we do nothing here. Standard Encoding
+	   is now located once for all fonts on the heap. For font-specific encodings
+	   we have to move all pointers appropriately, because this is entirely located
+	   in VM */
 	if (pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.arrayP
-	     == StdEncArrayP){ /* Font uses builtin encoding */
+	    == StdEncArrayP){ /* Font uses builtin StandardEncoding */
 	  ;
 	} 
 	else{ /* Font-specific encoding */ 
+	  ldummy=(long)pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.valueP;
+	  ldummy -=shift;
+	  pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.valueP=(char *)ldummy;
 	  for (k=0; k<256; k++){
 	    ldummy=(long)pFontBase->pFontArray[FontID].pType1Data->fontInfoP[j].value.data.arrayP[k].data.arrayP;
 	    /* The ".notdef" is also static and may not be shifted (Thanks, Derek ;) */
@@ -436,6 +473,11 @@
 	     (unsigned long)vm_base);
     T1_PrintLog( "T1_LoadFont()", err_warn_msg_buf, T1LOG_DEBUG);
   }
+#ifdef ANSI_REALLOC_ENFORCE_POINTERSHIFTING
+  /* If pointer shifting had been enforced by allocating from
+     scratch using malloc() free the previous vm. */
+  free( vm_base);
+#endif
 #endif
     
   /* Generate a message how much VM the current font consumes */
@@ -608,6 +650,7 @@
     }
     /* We now create an encoding-specific kerning table which will speed up
        looking for kerning pairs! */
+    pFontBase->pFontArray[FontID].KernMapSize=0;
     /* First, get number of defined kerning pairs: */
     k=pFontBase->pFontArray[FontID].pAFMData->numOfPairs;
     if (k>0){ /* i.e., there are any pairs */
@@ -850,7 +893,7 @@
 
 
 
-/* CreateNewFontSize( FontID, size): Create a new size "size" of font
+/* T1int_CreateNewFontSize( FontID, size): Create a new size "size" of font
    "FontID" and allocate all data necessary for this. The data
    structure is connected to the linked list of FontSizeDeps for this
    font. Returns a pointer to the newly created FontSizeDeps-struct
@@ -863,7 +906,7 @@
    2:     low-antialiased bytemaps are stored in this struct
    4:     high-antialiased bytemaps are stored in this struct
    */
-FONTSIZEDEPS *CreateNewFontSize( int FontID, float size, int aa)
+FONTSIZEDEPS *T1int_CreateNewFontSize( int FontID, float size, int aa)
 {
 
   FONTSIZEDEPS *pFontSizeDeps, *pPrev;
@@ -872,7 +915,7 @@
   /* First, get to the last font size in the linked list for this font.
      The following routine returns the address of the last struct in the
      linked list of FONTSIZEDEPS or NULL if none exists. */
-  pFontSizeDeps=GetLastFontSize( FontID);
+  pFontSizeDeps=T1int_GetLastFontSize( FontID);
   pPrev=pFontSizeDeps;
   
   
@@ -939,10 +982,10 @@
   
 
 
-/* QueryFontSize( FontID, size, aa): Search if a requested size of font
+/* T1_QueryFontSize( FontID, size, aa): Search if a requested size of font
    FontID is already existing. If so, it returns a pointer to the
    respective FontSizeDeps-structure,  otherwise NULL is returned: */
-FONTSIZEDEPS *QueryFontSize( int FontID, float size, int aa)
+FONTSIZEDEPS *T1int_QueryFontSize( int FontID, float size, int aa)
 {
   
   FONTSIZEDEPS *link_ptr;
@@ -967,10 +1010,10 @@
   
 }
 
-/* FONTSIZEDEPS *GetLastFontSize( FontID): Get the address of the
+/* FONTSIZEDEPS *T1int_GetLastFontSize( FontID): Get the address of the
    last struct in the linked list of FontSizeDeps or NULL if there is
    no existing size dependent data. */
-FONTSIZEDEPS *GetLastFontSize( int FontID)
+FONTSIZEDEPS *T1int_GetLastFontSize( int FontID)
 {
   FONTSIZEDEPS *link_ptr, *result_ptr;
   
diff -Nru t1lib-grace/T1lib/t1lib/t1load.h t1lib-deb/T1lib/t1lib/t1load.h
--- t1lib-grace/T1lib/t1lib/t1load.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1load.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1load.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-04-01
+  ----- Date:        2002-12-02
   ----- Description: This file is part of the t1-library. It contains
                      declarations and definitions for t1load.c.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2002. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -30,9 +30,9 @@
 
 int T1_LoadFont( int FontID);
 static int openFontMetricsFile( int FontID, int open_sloppy);
-FONTSIZEDEPS *CreateNewFontSize( int FontID, float size, int aa);
-FONTSIZEDEPS *GetLastFontSize( int FontID);
-FONTSIZEDEPS *QueryFontSize( int FontID, float size, int aa);
+FONTSIZEDEPS *T1int_CreateNewFontSize( int FontID, float size, int aa);
+FONTSIZEDEPS *T1int_GetLastFontSize( int FontID);
+FONTSIZEDEPS *T1int_QueryFontSize( int FontID, float size, int aa);
 int fontfcnA( char *env, int *mode, psfont *Font_Ptr);
 static int cmp_METRICS_ENTRY( const void *entry1, const void *entry2);
 extern char *vm_base; /* from fontfcn.c in initfont()! */
@@ -41,8 +41,8 @@
 #else
 
 extern int T1_LoadFont( int FontID);
-extern FONTSIZEDEPS *CreateNewFontSize( int FontID, float size, int aa);
-extern FONTSIZEDEPS *GetLastFontSize( int FontID);
-extern FONTSIZEDEPS *QueryFontSize( int FontID, float size, int aa);
+extern FONTSIZEDEPS *T1int_CreateNewFontSize( int FontID, float size, int aa);
+extern FONTSIZEDEPS *T1int_GetLastFontSize( int FontID);
+extern FONTSIZEDEPS *T1int_QueryFontSize( int FontID, float size, int aa);
 
 #endif
diff -Nru t1lib-grace/T1lib/t1lib/t1misc.h t1lib-deb/T1lib/t1lib/t1misc.h
--- t1lib-grace/T1lib/t1lib/t1misc.h	2004-04-13 13:27:44.000000000 -0700
+++ t1lib-deb/T1lib/t1lib/t1misc.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1misc.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-10-03
+  ----- Date:        2004-11-27
   ----- Description: This file is part of the t1-library. It contains
                      some miscellaneous definitions.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2004.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -55,7 +55,13 @@
 
 /* The maximum length of a PostScript name of a font: */
 #define MAXPSNAMELEN 256
-#define T1_MAXPATHLEN   1024
+#ifndef MAXPATHLEN
+#    ifdef PATH_MAX
+#        define MAXPATHLEN   PATH_MAX
+#    else
+#        define MAXPATHLEN   4096
+#    endif
+#endif
 
 /* The default resolution used by the library */
 #define DEFAULT_RES           72.0
@@ -71,7 +77,7 @@
 #if defined(VMS)
 # define DIRECTORY_SEP        "]"
 # define DIRECTORY_SEP_CHAR   ']'
-#elif defined(MSDOS) | defined(_WIN32) | defined(__EMX__) | defined(_MSC_VER)
+#elif defined(MSDOS) | defined(_WIN32) | defined(_MSC_VER)
 # define DIRECTORY_SEP        "\\"
 # define DIRECTORY_SEP_CHAR   '\\'
 #else
@@ -176,6 +182,7 @@
 #define T1ERR_NO_AFM_DATA             16
 #define T1ERR_X11                     17
 #define T1ERR_COMPOSITE_CHAR          18
+#define T1ERR_SCAN_ENCODING           19
 
 
 /* The info_flags meaning */
@@ -183,9 +190,10 @@
 #define AFM_SLOPPY_SUCCESS        (short)0x0002
 #define AFM_SELFGEN_SUCCESS       (short)0x0004
 #define USES_STANDARD_ENCODING    (short)0x0008
+#define RASTER_STROKED            (short)0x0010
+#define CACHE_STROKED             (short)0x0020
 #define FONT_NOCACHING            (short)0x0100
 
-
 #ifndef PI
 #define PI 3.1415927
 #endif
diff -Nru t1lib-grace/T1lib/t1lib/t1outline.c t1lib-deb/T1lib/t1lib/t1outline.c
--- t1lib-grace/T1lib/t1lib/t1outline.c	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1outline.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1outline.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-05-27
+  ----- Date:        2005-05-01
   ----- Description: This file is part of the t1-library. It contains
                      functions for getting glyph outline descriptions of
 		     strings and characters.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -52,8 +52,8 @@
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
-#include "../type1/regions.h"
 #include "../type1/paths.h"
+#include "../type1/regions.h"
 
 
 #include "t1types.h"
@@ -121,7 +121,7 @@
 
   
   /* First, check for a correct ID */
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i==-1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
@@ -141,8 +141,8 @@
   
   /* font is now loaded into memory =>
      Check for size: */
-  if ((font_ptr=QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
-    font_ptr=CreateNewFontSize( FontID, size, NO_ANTIALIAS);
+  if ((font_ptr=T1int_QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
+    font_ptr=T1int_CreateNewFontSize( FontID, size, NO_ANTIALIAS);
     if (font_ptr==NULL){
       T1_errno=T1ERR_ALLOC_MEM;
       return(NULL);
@@ -175,7 +175,7 @@
 				       fontarrayP->pFontEnc,
 				       ucharcode, &mode,
 				       fontarrayP->pType1Data,
-				       DO_NOT_RASTER);
+				       DO_NOT_RASTER,0.0f);
   KillSpace (Current_S);
 
   return((T1_OUTLINE *)charpath);
@@ -224,7 +224,7 @@
   ustring=(unsigned char*)string;
   
   /* First, check for a correct ID */
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i==-1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
@@ -250,8 +250,8 @@
   
   /* font is now loaded into memory =>
      Check for size: */
-  if ((font_ptr=QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
-    font_ptr=CreateNewFontSize( FontID, size, NO_ANTIALIAS);
+  if ((font_ptr=T1int_QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
+    font_ptr=T1int_CreateNewFontSize( FontID, size, NO_ANTIALIAS);
     if (font_ptr==NULL){
       T1_errno=T1ERR_ALLOC_MEM;
       return(NULL);
@@ -326,7 +326,7 @@
 					       no_chars, &mode,
 					       fontarrayP->pType1Data,
 					       kern_pairs, spacewidth,
-					       DO_NOT_RASTER);
+					       DO_NOT_RASTER,0.0f);
   KillSpace (Current_S);
   
   /* In all cases, free memory for kerning pairs */
@@ -378,7 +378,7 @@
 
 
   /* First, check for a correct ID */
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i==-1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
@@ -398,8 +398,8 @@
   
   /* font is now loaded into memory =>
      Check for size: */
-  if ((font_ptr=QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
-    font_ptr=CreateNewFontSize( FontID, size, NO_ANTIALIAS);
+  if ((font_ptr=T1int_QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
+    font_ptr=T1int_CreateNewFontSize( FontID, size, NO_ANTIALIAS);
     if (font_ptr==NULL){
       T1_errno=T1ERR_ALLOC_MEM;
       return(NULL);
diff -Nru t1lib-grace/T1lib/t1lib/t1outline.h t1lib-deb/T1lib/t1lib/t1outline.h
--- t1lib-grace/T1lib/t1lib/t1outline.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1outline.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1outline.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-05-27
+  ----- Date:        2002-10-18
   ----- Description: This file is part of the t1-library. It contains
                      definitions and declarations for t1outline.c.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2002. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -72,13 +72,15 @@
 			       struct XYspace *S, char **ev,
 			       unsigned char index, int *mode,
 			       psfont *Font_Ptr,
-			       int do_raster);
+			       int do_raster,
+			       float strokewidth);
 extern struct region *fontfcnB_string( int FontID, int modflag,
 				       struct XYspace *S, char **ev,
 				       unsigned char *string, int no_chars,
 				       int *mode, psfont *Font_Ptr,
 				       int *kern_pairs, long spacewidth,
-				       int do_raster);
+				       int do_raster,
+				       float strokewidth);
 extern struct region *fontfcnB_ByName( int FontID, int modflag,
 				       struct XYspace *S,
 				       char *charname,
